sub init()
    m.label = m.top.findNode("label")
    m.counter = m.top.findNode("counter")
    m.thumb = m.top.findNode("thumb")
    m.focusBg = m.top.findNode("focusBg")
    m.lastFocusPercent = 0

    updateFocusUI(false)
end sub

sub onItemContentChanged()
	itemcontent = m.top.itemContent
	if (itemcontent = invalid) return
    m.label.text = itemcontent.SHORTDESCRIPTIONLINE1
    m.counter.text = itemcontent.counter
    m.thumb.uri = itemcontent.HDGRIDPOSTERURL
end sub

function onFocusPercentChanged() as void
    focusPercent = m.top.focusPercent
	updateFocusUI(m.lastFocusPercent < focusPercent)
    m.lastFocusPercent = focusPercent
end function

function onListHasFocusChanged() as void
    if (m.top.focusPercent = 1)
        updateFocusUI(true)
    end if
end function

function updateFocusUI(itemHasFocus as boolean) as void
	m.label.color = "#ffffff"
    m.counter.color = "#ffffff"
    if (itemHasFocus)
		if (m.top.listHasFocus)
			m.focusBg.blendColor = "#ffffff"
			m.label.color = "#000000"
            m.counter.color = "#000000"
		else
			m.focusBg.blendColor="0xffffff80"
		end if
	else
		m.focusBg.blendColor="#00000000"
	end if
end function