function init()
	m.top.id = "markuplistitem"
	m.itemicon = m.top.findNode("itemIcon")
	m.itemlabel = m.top.findNode("itemLabel")
	m.focusBg = m.top.findNode("focusBg")
	m.lastFocusPercent = 0
	updateFocusUI(false)
	m.global.observeField("selectedVideoId", "onSelectedVideoIdChanged")
end function

function onSelectedVideoIdChanged()
	if (m.top.focusPercent = 1)
        updateFocusUI(true)
	else
		updateFocusUI(false)
    end if
end function

function updateItemSize()
	m.itemLabel.maxWidth = m.top.width - 40
end function

sub onItemContentChanged()
	m.itemcontent = m.top.itemContent
	if (m.itemcontent = invalid) return
	if (m.itemcontent.logo <> invalid) 
		m.itemicon.uri = m.itemcontent.logo
	else
		m.itemicon.uri = m.itemcontent.cover
	end if
	m.itemlabel.text = m.itemcontent.title
end sub

function onFocusPercentChanged() as void
    focusPercent = m.top.focusPercent
	updateFocusUI(m.lastFocusPercent < focusPercent)
    m.lastFocusPercent = focusPercent
end function

function onListHasFocusChanged() as void
    if (m.top.focusPercent = 1)
        updateFocusUI(true)
    end if
end function

function updateFocusUI(itemHasFocus as boolean) as void
	currentVideoFocus = false
	if (m.itemcontent <> invalid)
		currentVideoFocus = (m.global.selectedVideoId = m.itemcontent.id)
	end if

	m.itemlabel.color = "#ffffff"
	m.itemlabel.repeatCount = 0
    if (itemHasFocus)
		if (m.top.listHasFocus)
			m.focusBg.blendColor = "#ffffff"
			m.itemlabel.color = "#000000"
			m.itemlabel.repeatCount = -1
		else
			m.focusBg.blendColor="#ffffff99"
		end if
	else
		m.focusBg.blendColor="#00000000"
	end if

	if (currentVideoFocus and not itemHasFocus)
		m.focusBg.blendColor="#ffffff99"
		m.itemlabel.color = "#ffffff"
		m.itemlabel.repeatCount = -1
	end if
end function