sub init()
    m.HOME_PAGE_TITLE = "Categories"
    m.MANAGE_LISTS_TITLE = "Manage Playlists"
    m.INFO_PAGE_TITLE = "Info"

    m.loadingIndicator = m.top.findNode("loadingIndicator")
    m.loadingIndicator.control = "start"

    m.playlistView = m.top.findNode("playlistView")
    m.manageListsView = m.top.findNode("manageListsView")
    m.portalView = m.top.findNode("portalView")
    m.mainMenu = m.top.findNode("mainMenu")
    m.rokuSignUp = m.top.findNode("rokuSignUp")

    m.mainMenu.observeField("pageNameSelected","onPageChanged")
    m.mainMenuOutAnim = m.top.findNode("mainMenuOutAnim")
    m.mainMenuInAnim = m.top.findNode("mainMenuInAnim") 
    m.top.findNode("companyLogo").uri = m.global.BASE_URL + "/assets/sageiptv.png"
    m.top.findNode("background").color = m.global.appColor
    m.global.ObserveField("isSubscribe", "onGlobalIsSubscribeChanged")
    m.accountRegisteredTimer = CreateObject("roSGNode", "Timer")
    m.accountRegisteredTimer.setFields({
        duration: 15,
        repeat: true
    })
    m.accountRegisteredTimer.observeField("fire", "isAccountRegistered")
    m.init = true
end sub

sub isAccountRegistered()
    doRequest("isRegistered", sub(response)
        m.global.isLoggedIn = response.isregistered
        m.global.isSubscribe = response.isActivated

        if (m.global.isSubscribe AND m.init)
            handleAgruments()
        else if (NOT m.global.isSubscribe)
            onGlobalIsSubscribeChanged()
        end if
        m.init = false
    end sub, {baseURL: m.global.BASE_URL, email: getSavedEmail()})
end sub 

sub onArgsChange(event as Object)
    email = getSavedEmail()
    m.global.token = getSavedToken()

    if (len(m.global.token) = 0)
        doRequest("getEmail", sub(response)
            m.global.device_email = response.email
            checkIfTheAccountIsShared()
        end sub)
    else
        m.global.device_email = email
        checkIfTheAccountIsShared()
    end if
end sub

sub onGlobalIsSubscribeChanged()
    if (NOT m.global.isSubscribe)
        portalViewIndex = 0
        playlistViewIndex = 0
        for i = 0 to m.top.getChildCount() - 1
            item = m.top.getChild(i)
            if (item.id = "portalView")
                portalViewIndex = i
            else if (item.id = "playlistView")
                playlistViewIndex = i
            end if
        end for

        saveMode("list")
        m.top.removeChild(m.playlistView)
        m.top.removeChild(m.portalView)

        m.portalView = CreateObject("roSGNode", "PortalView")
        m.portalView.id =  "portalView"
        m.playlistView = CreateObject("roSGNode", "PlaylistView")
        m.playlistView.id =  "playlistView"
        m.portalView.visible = false
        m.playlistView.visible = false
        m.manageListsView.visible = false
        m.top.insertChild(m.playlistView, playlistViewIndex)
        m.top.insertChild(m.portalView, portalViewIndex)
        m.playlistView.callFunc("initContent")
        m.manageListsView.callFunc("initContent")
        m.mainMenu.pageNameSelected = m.INFO_PAGE_TITLE
        m.mainMenu.callFunc("resetLayout")

        if (m.mainMenu.visible) m.mainMenuOutAnim.control = "start"
    end if
end sub

sub handleAgruments()
    m.manageListsView.callFunc("initContent")
    if (NOT m.global.isSubscribe) saveMode("list")

    if (Instr(0, getSavedMode(),"list") > 0) 
        ' loadHomeContent()
        m.playlistView.visible = true
        m.portalView.visible = false
        m.playlistView.callFunc("initContent")
    else
        m.playlistView.visible = false
        m.portalView.visible = true
        m.portalView.callFunc("initContent")
    end if
end sub

sub checkIfTheAccountIsShared()
    doRequest("isShareAccount", sub(response)
        if response.shared_account
            m.mainMenu.items = [
                m.HOME_PAGE_TITLE,
                m.INFO_PAGE_TITLE
            ]
        else
            m.mainMenu.items = [
                m.HOME_PAGE_TITLE,
                m.MANAGE_LISTS_TITLE,
                m.INFO_PAGE_TITLE
            ]
        end if
        m.accountRegisteredTimer.control = "start"
        isAccountRegistered()
    end sub, {baseURL: m.global.BASE_URL, email: getEmail()})
end sub

sub onPageChanged()
    name = m.mainMenu.pageNameSelected
    if (NOT m.global.isSubscribe) saveMode("list")
    m.listMode = (Instr(0, getSavedMode(),"list") > 0)
    m.manageListsView.visible =  (name = m.MANAGE_LISTS_TITLE)
    m.playlistView.visible = false
    m.portalView.visible = false

    if name = m.HOME_PAGE_TITLE
        if (m.listMode)
            m.playlistView.visible = true
            m.portalView.visible = false
            m.playlistView.setFocus(true)
            if (m.mainMenu.shouldReloadContent) m.playlistView.callFunc("initContent")
        else
            m.portalView.visible = true
            m.playlistView.visible = false
            m.portalView.setFocus(true)
            if (m.mainMenu.shouldReloadContent) m.portalView.callFunc("initContent")
        end if

    else if name = m.MANAGE_LISTS_TITLE
        m.manageListsView.setFocus(true)
        if (m.mainMenu.shouldReloadContent) m.manageListsView.callFunc("initContent")
    else if name = m.INFO_PAGE_TITLE
        showBilling()
    end if
    m.mainMenuOutAnim.control = "start"
    if (m.rokuSignUp <> invalid) m.rokuSignUp.show = (name = m.INFO_PAGE_TITLE)
end sub

sub showBilling()
    m.rokuSignUp.isAuthNeeded = true
    m.rokuSignUp.setFocus(true)
    m.rokuSignUp.buttonLoginFlow.SetFields({
        focusBitmapUri  : "pkg:/images/button_on.9.png"
        focusedIconUri  : "pkg:/images/login.png"
        iconUri         : "pkg:/images/login.png"
    })
    m.rokuSignUp.buttonSubscribeFlow.SetFields({
        focusBitmapUri  : "pkg:/images/button_on.9.png"
        visible         : false
    })
    m.rokuSignUp.buttonLogoutFlow.SetFields({
        focusBitmapUri  : "pkg:/images/button_on.9.png"
        visible         : false
    })
    m.rokuSignUp.buttonSignupFlow.SetFields({
        focusBitmapUri  : "pkg:/images/button_on.9.png"
        focusedIconUri  : "pkg:/images/signup.png"
        iconUri         : "pkg:/images/signup.png"
    })
    m.rokuSignUp.dialogsButtonConfig = {
        focusBitmapUri : "pkg:/images/button_on.9.png"
    }
    m.rokuSignUp.ObserveField("isSubscribed", "On_rokuSignUp_isSubscribed")

end Sub


' Handler for processing RokuSignUp flow result.
sub On_rokuSignUp_isSubscribed(event as Object)
    m.global.isSubscribe = event.getData()

    if m.global.isSubscribe then
        if m.rokuSignUp.isAfterLoginAuthFlow then
            On_msgDialog_buttonSelected()
        else
            msgDialog = CreateObject("roSGNode", "BackDialog")
            msgDialog.buttons = ["Continue"]
            msgDialog.buttonGroup.focusBitmapUri = "pkg:/images/button_on.9.png"
            msgDialog.ObserveField("buttonSelected", "On_msgDialog_buttonSelected")
            msgDialog.ObserveField("isBackPressed", "On_msgDialog_buttonSelected")
            msgDialog.title = "Registered successfully"
            m.top.dialog = msgDialog
        end if
    else
        if m.top.dialog <> invalid
            m.top.dialog.close = true
        end if
    end if
end sub


' Handler for processing subscription result dialog button selection.
sub On_msgDialog_buttonSelected()
    if m.top.dialog <> invalid
        m.top.dialog.close = true
    end if
end sub

sub saveSubscription(purchaseId as String)
    if len(purchaseId) > 0
        doRequest("saveSubscription", sub(response)
        end sub,{purchaseId: purchaseId, baseURL: m.global.BASE_URL, email: m.global.device_email})
    end if
end sub

sub showNonSubscribeNotification()
    dialogBillingNA = CreateObject("roSGNode", "BackDialog")
    dialogBillingNA.title = "Activate Your Lifetime Premium Access!"
    dialogBillingNA.message = "To watch the video, Please Activate Your Lifetime Premium Access. Under info click <Activate Your Lifetime Premium Access> button and follow the steps on the screen if you have already signed up."
    dialogBillingNA.buttons = ["OK"]
    dialogBillingNA.ObserveField("buttonSelected", "OnNoSubscriptionAlertClick")
    m.top.dialog = dialogBillingNA
end sub

sub OnNoSubscriptionAlertClick()
    m.top.dialog.close = true
end sub

function onKeyEvent(key as String, press as Boolean) as Boolean
    isHandled = false
    if (press)
        if (key="up" or key="back")
            if (m.mainMenu.translation[1] = -100)
                m.mainMenuInAnim.control = "start"
                m.mainMenu.setFocus(true)
                isHandled = true
            end if

        end if
    end if

    return isHandled
end function