sub init()
    m.global.observeField("appColor","onAppColorChange")

    m.rectangle = m.top.CreateChild("Rectangle")
    m.rectangle.width = 1280
    m.rectangle.height = 720
    m.rectangle.color = m.global.appColor

    m.group = m.top.createChild("LayoutGroup")
    m.group.translation = [650, 50]
    m.group.itemSpacings = [40, 0]
    m.group.horizAlignment = "center"
    m.group.vertAlignment = "top"
    m.group.layoutDirection = "vert"

    m.logoGroup = m.group.createChild("LayoutGroup")
    m.logoGroup.layoutDirection = "horiz"
    m.logoGroup.vertAlignment = "bottom"
    m.logoGroup.translation = [550, 50]

    m.logo = m.logoGroup.createChild("Poster")
    m.logo.uri = "pkg:/images/logo.png"

    'get Channel version
    appInfo = CreateObject("roAppInfo")
    m.version = m.logoGroup.CreateChild("Label")
    m.version.Font.size = 16
    m.version.horizAlign = "center"
    m.version.vertAlign = "center"
    m.version.text = "V" + appInfo.GetVersion()

    m.activateTextGroup = m.group.createChild("LayoutGroup")
    m.activateTextGroup.layoutDirection = "vert"
    m.activateTextGroup.translation = [480,150]
    m.activateTextGroup.itemSpacings = [30,80,90]

    m.activateCodeHeading = m.activateTextGroup.CreateChild("Label")
    m.activateCodeHeading.horizAlign = "center"
    m.activateCodeHeading.vertAlign = "center"
    m.activateCodeHeading.text = "Enter the activation code at"

    m.activateUrl = m.activateTextGroup.CreateChild("Label")
    m.activateUrl.horizAlign = "center"
    m.activateUrl.vertAlign = "center"
    m.activateUrl.text = "https://www.sageiptv.co/activate"

    m.codeRect = m.activateTextGroup.CreateChild("Rectangle")
    m.codeRect.translation = [50,0]
    m.codeRect.width = 450
    m.codeRect.height = 80
    m.codeRect.color = "#000000"

    m.codeLabel = m.codeRect.CreateChild("Label")

    m.codeLabel.font = "font:LargeSystemFont"
    m.codeLabel.translation = [80,17.5]
    m.codeLabel.text = ""
    m.codeLabel.font.size = 38

    m.top.regenerateActivationCodeButton = m.top.createChild("Button")
    m.top.regenerateActivationCodeButton.text = "Request New Activation Code"
    m.top.regenerateActivationCodeButton.minWidth = 450
    m.top.regenerateActivationCodeButton.maxWidth = 460
    m.top.regenerateActivationCodeButton.translation = [425,450]
    m.top.regenerateActivationCodeButton.showFocusFootprint = true
    m.top.regenerateActivationCodeButton.setFocus(true)
end sub

sub onSetActivationCode()
   m.codeLabel.text = m.top.activationCode
end sub

sub onAppColorChange(event as Object)
    m.rectangle.color = event.getData()
end sub
