function init()
    m.top.observeField("focusedChild", "onFocusedChildChanged")
    

    m.focusIndex = 0
    m.lastFocusIndex = 0
end function

function onFocusedChildChanged()
    if (m.top.hasFocus())
        focusItem(m.top.focusIndex)
    else
        focusItem(m.lastFocusIndex, "#FFFFFF")
    end if
end function

function focusItem(index, color="#0a75ad")
    item = m.top.getChild(index)
    item.blendColor = color
    item.getChild(0).color = "#000000"
    item.scale = [1.1, 1.1]
    m.lastFocusIndex = index
    m.top.focusIndex = index
end function

function unFocusItem(index)
    item = m.top.getChild(index)
    item.blendColor = "#848789"
    item.getChild(0).color = "#FFFFFF"
    item.scale = [1, 1]
end function

function onKeyEvent(key as string, isPressed as boolean) as boolean
    isHandled = false
    
    if (isPressed)
        if (key = "left")
            if (m.focusIndex > 0) m.focusIndex--
            unFocusItem(m.lastFocusIndex)
            focusItem(m.focusIndex) 
            isHandled = true
        else if (key = "right")
            if (m.focusIndex < m.top.getChildCount() - 1) m.focusIndex++
            unFocusItem(m.lastFocusIndex)
            focusItem(m.focusIndex) 
            isHandled = true
        end if
    end if

    return isHandled
end function