function init() as void
    m.keyboard = m.top.findNode("keyboard")
    m.cancelButton = m.top.findNode("cancelButton")
    m.oKButton = m.top.findNode("oKButton")

    keyRect = m.keyboard.boundingRect()
    m.keyboard.translation = [ (1280 - keyRect.width) / 2, (720 - keyRect.height) / 2 ]
    m.keyboard.textEditBox.observeField("text", "onTextChanged")
    ' m.keyboard.keyGrid.keyDefinitionUri = "pkg:/Keyboards/KeyboardKDF.json"
    m.top.observeField("focusedChild", "onFocusChanged")
    m.oKButton.observeField("selected", "onOKButtonSelected")
    m.cancelButton.observeField("selected", "onCancelButtonSelected")
    m.lastButtonFocused = m.oKButton
    m.top.findNode("background").color = m.global.appColor
end function

function onOKButtonSelected()
    m.top.close = true
end function

function onCancelButtonSelected()
    m.top.close = false
end function

function onTextChanged()
    m.top.text = m.keyboard.textEditBox.text
end function

function onFocusChanged()
    if m.top.hasFocus()
        m.keyboard.setFocus(true)
    end if
end function

function updateUI()
    m.keyboard.textEditBox.hintText = m.top.hintText
    m.keyboard.textEditBox.text = m.top.text
    m.keyboard.textEditBox.cursorPosition = len(m.top.text)
end function

function onKeyEvent(key as string, isPressed as boolean) as boolean
    handled = true

    if isPressed
        if key = "back"
            m.top.close = false
        else if key = "down"
            m.lastButtonFocused.setFocus(true)
        else if key = "up"
            m.keyboard.setFocus(true)
        else if key = "right" AND m.lastButtonFocused.hasFocus()
            if (m.lastButtonFocused <> invalid) m.lastButtonFocused.setFocus(false)
            m.oKButton.setFocus(true)
            m.lastButtonFocused = m.oKButton
        else if key = "left" AND m.lastButtonFocused.hasFocus()
            if (m.lastButtonFocused <> invalid) m.lastButtonFocused.setFocus(false)
            m.cancelButton.setFocus(true)
            m.lastButtonFocused = m.cancelButton
        end if
    end if

    return handled
end function