sub init()
    m.menuBackground = m.top.findNode("menuBackground")
    m.menuBackground.width = 1280
    m.menuBackground.height = 90
    m.menuBackground.translation = [0, 0]
    m.menuBackground.blendColor = "0x000000"

    m.menuList = m.top.FindNode("menuList")
    m.menuList.rowHeights = [80]
    m.menuList.numRows = 1

    m.top.observeField("focusedChild", "onFocusChange")
end sub

sub onMenuItemsChange(event as object)
    loadMenuContent(event.getData())
end sub

sub onItemSelected(event as object)
    if not m.top.visible or m.top.translation[1] < 0
        return
    end if

    m.top.shouldReloadContent = true
    m.top.pageNameSelected = m.top.items[event.getData()]
end sub

sub onFocusChange()
    if (m.top.hasFocus()) m.menuList.setFocus(true)
end sub

sub loadMenuContent(menuTitles as object)
    m.content = createObject("RoSGNode", "ContentNode")
    columnWidths = []
    width = 0
    columnsCount = 0
    spacingWidth = 30

    templateLable = createObject("RoSGNode", "Label")
    templateLable.font.size = 27
    templateLable.height = 44

    for each title in menuTitles
        dataItem = m.content.CreateChild("ContentNode")
        dataItem.title = title
        templateLable.text = title

        columnWidth = templateLable.boundingRect().width + 30

        width = width + columnWidth + spacingWidth

        if width < 1280
            columnsCount += 1
        end if
        columnWidths.push(columnWidth)
    end for

    widthItem = width / menuTitles.count()
    templateLable = invalid

    m.menuList.numColumns = columnsCount
    m.menuList.columnWidths = columnWidths
    m.menuList.itemSize = [widthItem * columnsCount, 50]
    m.menuList.itemSpacing = [spacingWidth, 0]

    m.menuList.content = m.content
    m.menuList.SetFocus(true)
    deviceInfo = CreateObject("roDeviceInfo")

    menuPosX = (1280 - m.menuList.boundingRect().width) / 2

    m.menuList.translation = [menuPosX, 30]

    m.menuList.ObserveField("itemSelected", "onItemSelected")
end sub

sub resetLayout()
    for i = 0 to m.menuList.count() - 1
        if (m.top.items[i] = m.top.pageNameSelected)
            m.menuList.jumpToItem = i
        end if
    end for
end sub

function OnkeyEvent(key, press) as boolean
    if (press)
        ?"[Menu] onKeyEvent = ";key
        if key = "down"
            m.top.shouldReloadContent = false
            m.top.pageNameSelected = m.top.items[m.menuList.itemFocused]
            return true
        else if key = "up"
            return true
        end if
    end if


    return false
end function