sub init()
    m.poster = m.top.findNode("poster")
    m.label = m.top.findNode("label")
    m.currentRect = m.top.findNode("currentRect")
    updateFocusUI(false)
    m.global.observeField("selectedVideoId", "onSelectedVideoIdChanged")
end sub

sub onContentChanged()
    m.itemContent = m.top.itemContent
    if (m.itemContent.cover <> invalid) m.poster.uri = m.itemContent.cover
    m.label.text = m.itemContent.name
end sub

function onFocusPercentChanged() as void
    focusPercent = m.top.focusPercent
	updateFocusUI(m.lastFocusPercent < focusPercent)
end function

function onRowListHasFocusChanged() as void
    if (m.top.focusPercent = 1)
        updateFocusUI(true)
    end if
end function

function onSelectedVideoIdChanged()
	if (m.top.focusPercent = 1)
        updateFocusUI(true)
	else
		updateFocusUI(false)
    end if
end function

function updateFocusUI(itemHasFocus as boolean) as void
	m.label.repeatCount = 0
    m.currentRect.visible = false
    if (m.itemContent <> invalid) m.currentRect.visible = (m.global.selectedVideoId = m.itemContent.id)
    if (itemHasFocus)
		if (m.top.RowListHasFocus)
			m.label.repeatCount = -1
		else
		end if
	else
	end if

    m.lastFocusPercent = m.top.focusPercent
end function

