sub init()
    m.HOME_PAGE_TITLE = "Categories"
    m.MANAGE_LISTS_TITLE = "Manage Playlists"
    m.INFO_PAGE_TITLE = "Info"
    
    m.nbrOK = 0
    
    'Logos'
    m.dialog = createObject("roSGNode", "ProgressDialog")
    m.dialog.backgroundUri = "pkg:/images/3b3b3b.png"
    m.dialog.title = "Please wait..."
    m.dialog.optionsDialog = true
    m.top.dialog = m.dialog

    m.miniKeyboard = m.top.findNode("miniKeyboard")
    m.videoDetailScreen = m.top.findNode("videoDetailScreen")
    m.searchGroup = m.top.findNode("searchGroup")
    m.warningInGroup = m.top.findNode("warningInGroup")
    m.warningDialog = m.top.findNode("warningDialog")
    m.okBtn = m.top.findNode("okBtn")
    m.videolist = m.top.findNode("videoLabelList")
    m.videolist.observeField("itemSelected", "playvideo")
    m.videolist.observeField("itemFocused", "onVideoItemFocusChange")
    
    m.video = m.top.findNode("selectedVideo")
    m.video.observeField("state", "controlvideoplay")
    
    m.favouriteButton = m.top.findNode("favouriteButton")
    
    m.tvPoster = m.top.findNode("tvPoster")
    m.loadingIndicator = m.top.findNode("loadingIndicator")
    m.loadingIndicator.control = "start"
    m.noResults = m.top.findNode("noResults")
    m.companyLogo = m.top.findNode("companyLogo")
    m.homeGridHolder = m.top.findNode("homeListHolder")
    
    m.ManageListsScreen = m.top.findNode("ManageListsScreen")
    m.PortalScreen = m.top.findNode("PortalScreen")
    
    'Init menu's component
    m.mainMenu = m.top.findNode("mainMenu")
    m.mainMenu.observeField("pageNameSelected","OnPageChange")
    m.mainMenu.observeField("focus","OnMenuFocusChange")
    m.mainMenuOutAnim = m.top.findNode("mainMenuOutAnim")
    m.mainMenuOutInterpolator = m.top.findNode("mainMenuOutInterpolator")
    m.mainMenuOutInterpolator.keyValue = [ [0, 0], [0, -100] ]

    m.mainMenuInAnim = m.top.findNode("mainMenuInAnim") 
    m.mainMenuInInterpolator = m.top.findNode("mainMenuInInterpolator")
    m.mainMenuInInterpolator.keyValue= [ [0, -100] , [0, 0] ]
    m.mainMenu.visible = false
    
    m.SelectedIndex = 0
end sub

sub onArgsChange(event as Object)
    m.args = event.getData()
    
    email = getSavedEmail()
    m.global.token = getSavedToken()
    if (len(m.global.token) = 0)
        doRequest("getEmail", sub(response)
            m.global.device_email = response.email
            handleAgruments(m.args)
        end sub)
    else    
        m.global.device_email = email
        handleAgruments(m.args)
    end if    
end sub

sub handleAgruments(args as Object)
    mediaType = args.mediaType
    channelID = args.contentID
    if (mediaType = "short-form" OR mediaType = "special")
    else
        m.global.isSubscribe = len(m.global.token) > 0
            
        'load Manage lists
        m.ManageListsScreen.callFunc("loadLists", invalid)
        m.ManageListsScreen.callFunc("loadPortalLists", invalid)
        if (NOT m.global.isSubscribe) saveMode("list")
        checkIfTheAccountIsShared()
        if (Instr(0, getSavedMode(),"list") > 0) 
            loadHomeContent()
        else
            m.PortalScreen.visible = true
            ' m.PortalScreen.setFocus(true)
        end if
    end if
end sub

sub checkIfTheAccountIsShared()
    doRequest("isShareAccount", sub(response)
        if response.shared_account
            m.mainMenu.items = [
                m.HOME_PAGE_TITLE,
                m.INFO_PAGE_TITLE
            ]
        else
            m.mainMenu.items = [
                m.HOME_PAGE_TITLE,
                m.MANAGE_LISTS_TITLE,
                m.INFO_PAGE_TITLE
            ]
        end if
        m.mainMenu.visible = true
    end sub, {baseURL: m.global.BASE_URL, email: getEmail()})
end sub

sub OnPageChange(event as Object)
    name = event.getData()
    if (NOT m.global.isSubscribe) saveMode("list")
    if (m.homeGrid <> invalid and (Instr(0, getSavedMode(),"list") > 0))
        m.homeGrid.visible = (name = m.HOME_PAGE_TITLE)
        m.PortalScreen.visible = false
    else if (Instr(0, getSavedMode(),"list") = 0)
        if (name = m.HOME_PAGE_TITLE)
            m.PortalScreen.visible = true
            m.PortalScreen.setFocus(true)
        else
            m.PortalScreen.visible = false
        end if
    end if
    
    m.ManageListsScreen.visible =  (name = m.MANAGE_LISTS_TITLE)
    if (m.rokuSignUp <> invalid)
        m.rokuSignUp.show = (name = m.INFO_PAGE_TITLE)
    end if
    
    if name = m.HOME_PAGE_TITLE
        loadHomeContent()
    else if name = m.MANAGE_LISTS_TITLE
        m.ManageListsScreen.callFunc("loadLists", invalid)
        m.ManageListsScreen.callFunc("loadPortalLists", invalid)
    else if name = m.INFO_PAGE_TITLE
        showBilling()
    end if
    
    m.mainMenuOutAnim.control = "start"
    executeAfterDelay("hideMenu", 0.3)
    m.homeGrid.setFocus(true)
end sub

sub OnMenuFocusChange(event as Object)
    focus = event.getData()
    if NOT focus then
        m.mainMenuOutAnim.control = "start"
        executeAfterDelay("hideMenu", 0.3)
    else
        m.mainMenuInAnim.control = "start"
        m.mainMenu.focus = true
        m.mainMenu.visible = true
    end if
end sub

sub hideMenu()
    m.mainMenu.visible = false
    if m.homeGrid <> invalid and m.homeGrid.visible
        m.homeGrid.setFocus(true)
    else if m.ManageListsScreen.visible
        m.ManageListsScreen.focus = true 
    else if m.rokuSignUp <> Invalid AND m.rokuSignUp.visible
        m.rokuSignUp.show = true
    end if
end sub

sub showBilling()
    if (m.homeGrid <> invalid)
        m.homeGrid.visible = false
    end if
    
    m.rokuSignUp = m.top.findNode("rokuSignUp")
    deviceinfo = createObject("roDeviceInfo")
    m.rokuSignUp.isAuthNeeded = true
    m.rokuSignUp.show = true
    m.rokuSignUp.setFocus(true)
    m.rokuSignUp.buttonLoginFlow.SetFields({
        focusBitmapUri  : "pkg:/images/button_on.9.png"
        focusedIconUri  : "pkg:/images/login.png"
        iconUri         : "pkg:/images/login.png"
    })
    m.rokuSignUp.buttonSubscribeFlow.SetFields({
        focusBitmapUri  : "pkg:/images/button_on.9.png"
        visible         : false
    })
    m.rokuSignUp.buttonLogoutFlow.SetFields({
        focusBitmapUri  : "pkg:/images/button_on.9.png"
        visible         : false
    })
    m.rokuSignUp.buttonSignupFlow.SetFields({
        focusBitmapUri  : "pkg:/images/button_on.9.png"
        focusedIconUri  : "pkg:/images/signup.png"
        iconUri         : "pkg:/images/signup.png"
    })
    m.rokuSignUp.dialogsButtonConfig = {
        focusBitmapUri : "pkg:/images/button_on.9.png"
    }
    m.rokuSignUp.ObserveField("isSubscribed", "On_rokuSignUp_isSubscribed")

end Sub


' Handler for processing RokuSignUp flow result.
sub On_rokuSignUp_isSubscribed(event as Object)
    m.global.isSubscribe = event.getData()

    if m.global.isSubscribe then
        if m.rokuSignUp.isAfterLoginAuthFlow then
            On_msgDialog_buttonSelected()
        else
            msgDialog = CreateObject("roSGNode", "BackDialog")
            msgDialog.buttons = ["Continue"]
            msgDialog.buttonGroup.focusBitmapUri = "pkg:/images/button_on.9.png"
            msgDialog.ObserveField("buttonSelected", "On_msgDialog_buttonSelected")
            msgDialog.ObserveField("isBackPressed", "On_msgDialog_buttonSelected")
            msgDialog.title = "Registered successfully"
            m.top.dialog = msgDialog
        end if
    else
        if m.top.dialog <> invalid
            m.top.dialog.close = true
        end if
    end if
end sub


' Handler for processing subscription result dialog button selection.
sub On_msgDialog_buttonSelected()
    if m.top.dialog <> invalid
        m.top.dialog.close = true
    end if
end sub

sub saveSubscription(purchaseId as String)
    if len(purchaseId) > 0
        doRequest("saveSubscription", sub(response)
        end sub,{purchaseId: purchaseId, baseURL: m.global.BASE_URL, email: m.global.device_email})
    end if
end sub


sub loadHomeContent() as void
    if (Instr(0, getSavedMode(),"list") = 0)
        if m.top.dialog <> invalid
            m.top.dialog.close = true
        end if

        if (m.homeGrid <> invalid) m.homeGrid.content = invalid
        return
    end if
    'clear current Home content before reloading
    if m.homeGrid <> invalid
        m.homeGrid.content = invalid
        
        'no content loading needed when the home page is not visible
        if (NOT m.homeGrid.visible)
            return
        end if
    end if
    'show loading before start load categories
    m.top.dialog = m.dialog
    
    'start loading categories
    doRequest("getHomeContent", sub(response)
        config = response.config 
        updateHomeDisplayMode(config.display_mode)
        'Update screen background
        m.top.backgroundURI = "pkg:/images/662d91.png"
        
        'init variables
        m.allVideoList = []
        m.allCategoryList = []
        m.searched = false
        m.searchContentExist = false
        m.tvPoster.uri = m.global.BASE_URL + "/assets/m-series-quality.png"
        m.companyLogo.uri = m.global.BASE_URL + "/assets/sageiptv.png"
        
        m.allCategoryList = response.categoryList
        showHomeGrid(response.content)
        'hide loading
        if m.top.dialog <> invalid
            m.top.dialog.close = true
        end if
    end sub, {baseURL: m.global.BASE_URL, email: getEmail()})    
end sub

sub updateHomeDisplayMode(displayMode as String)
    if (m.homeGridHolder.getChildCount() > 0)
        m.homeGridHolder.removeChild(0)
    end if    
    
    m.homeGrid = CreateObject("roSGNode", "MarkupGrid")
    m.homeGrid.vertFocusAnimationStyle = "floatingFocus"
    if displayMode = "list"
        m.homeGrid.itemComponentName = "HomeContentListItem"
        m.homeGrid.itemSize = [ 500, 50 ]
        m.homeGrid.numColumns = 1
        m.homeGrid.numRows = 8
        m.homeGrid.focusBitmapUri = "null"
        m.homeGrid.focusFootprintBitmapUri = "null"
        m.homeGrid.itemSpacing = [ 0, 15 ]
    else
        m.homeGrid.itemComponentName = "HomeContentItem"
        m.homeGrid.itemSize = [ 200, 180 ]
        m.homeGrid.numColumns = 5
        m.homeGrid.numRows = 2
        m.homeGrid.itemSpacing = [ 30, 30 ]
    end if
    m.homeGrid.setFocus(NOT m.mainMenu.visible)
    m.homeGridHolder.appendChild(m.homeGrid)
end sub

sub showHomeGrid(content as Object)
    if m.top.dialog <> invalid
        m.top.dialog.close = true
    end if
    m.homeGrid.content = content
    
    executeAfterDelay("jump", 0.3)
end sub

sub jump()
    m.homeGrid.jumpToItem = m.SelectedIndex
end sub

sub onVideoItemFocusChange(event as Object)
  focusedIndex = event.getData()
  if (focusedIndex > m.videoList.content.getChildCount())
    return
  end if
  
  focusedContent = m.videolist.content.getChild(focusedIndex)
  if (focusedContent <> invalid) 
    m.favouriteButton.visible = (m.global.selectedVideoID = focusedContent.id)
    m.nbrOK = 0
  end if
end sub

sub playvideo(playingIndex = -1 as Integer)
    if (m.global.isLoggedIn AND NOT m.global.isSubscribe)
        showNonSubscribeNotification()
        return
    end if
    
    if playingIndex = -1
        index = m.videolist.itemFocused
    else 
        index = playingIndex
    end if
    m.videocontent = m.videolist.content.getChild(index)
    m.global.selectedVideoTitle  = m.videocontent.TITLE 'when auto-played get channel title. 
    
    'check if the selected channel is is favorites and update the button text
    doRequest("checkChannelInFavorites", sub(response)
        if response.is_favorite
           m.favouriteButton.text = "Remove from Favourites"
        else
           m.favouriteButton.text = "Add to Favourites"
        end if
        
        m.favouriteButton.visible = true
    end sub, {
        baseURL: m.global.BASE_URL,
        email: getEmail(),
        channelID:  getCurrentFocusedChannelName()
    })
    m.videocontent.streamFormat = "auto"
    if m.global.selectedVideoID <> m.videocontent.id
        m.video.control = "stop"
        m.video.content = m.videocontent
        m.video.globalCaptionMode = "On"
        m.video.control = "play"
        m.video.visible = true
        m.global.selectedVideoID = m.videocontent.id
        m.global.selectedVideoTitle = m.videocontent.TITLE 'SAGEIPTV
    end if
end sub

function getCurrentFocusedChannelName() as String
   
    if m.global.selectedVideoTitle = Invalid
    return ""
    else 
     return m.global.selectedVideoTitle
    end if 
end function

function getCurrentFocusedChannelID() as String
    return m.global.selectedVideoID
end function

sub showNonSubscribeNotification()
    dialogBillingNA = CreateObject("roSGNode", "BackDialog")
    dialogBillingNA.title = "Activate Your Lifetime Premium Access!"
    dialogBillingNA.message = "To watch the video, Please Activate Your Lifetime Premium Access. Under info click <Activate Your Lifetime Premium Access> button and follow the steps on the screen if you have already signed up."
    dialogBillingNA.buttons = ["OK"]
    dialogBillingNA.ObserveField("buttonSelected", "OnNoSubscriptionAlertClick")
    m.top.dialog = dialogBillingNA
end sub

sub OnNoSubscriptionAlertClick()
    m.top.dialog.close = true
end sub

sub controlvideoplay(event as Object)
    state = event.getData()
    if state = "buffering"
        m.video.enableUI = false
        m.loadingIndicator.visible = true
    else if state = "playing"
        if (m.mode = "full")
            m.video.enableUI = true
        end if    
        m.loadingIndicator.visible = false
    else if (state = "finished")
        m.videolist.setFocus(true)
        ToggleScreen("small")
        m.nbrOK = 0
        m.loadingIndicator.visible = false
    else if state = "error"
        m.nbrOK = 0
        showErrorDialog(m.video.errorMsg)
    end if
end sub

sub showErrorDialog(message)
     dialog = createObject("roSGNode", "Dialog")
     dialog.backgroundUri = "pkg:/images/3b3b3b.png"
     dialog.title = "PlayBack Error"
     dialog.optionsDialog = true
     dialog.iconUri = ""
     dialog.message = message
     dialog.width = 450
     dialog.buttons = ["OK"]
     dialog.optionsDialog = true
     dialog.observeField("buttonSelected", "closeDialog")
     m.top.dialog = dialog
end sub

sub closeDialog()
    m.top.dialog.close = true
    m.videolist.setFocus(true)
    ToggleScreen("small")
end sub

function onKeyEvent(key as String, press as Boolean) as Boolean
    if press then
        if key = "options" AND NOT m.mainMenu.visible AND NOT m.videoDetailScreen.visible
            m.mainMenu.focus = true
            return true
        else if key = "up" AND NOT m.mainMenu.visible AND NOT m.videoDetailScreen.visible
            m.mainMenu.focus = true
            return true
        else if key = "back" then
            if isMainScreenHasFocus() AND NOT m.mainMenu.visible then
                m.mainMenu.focus = true
                return true
            else if m.mainMenu.visible then
                return false
            else if m.searched and ( m.videolist.hasFocus() or m.miniKeyboard.isInfocusChain()) then
                m.miniKeyboard.text = ""
                searchQuery(true)
                m.searched = false
                m.global.selectedVideoID = ""
                m.global.selectedVideoTitle = ""
                setListFocus()
                return true
            else if m.video.hasFocus() then
                m.videolist.setFocus(true)
                ToggleScreen("small")
                return true
            else
                m.loadingIndicator.visible = false
                m.searchGroup.visible = false
                m.videoDetailScreen.visible = false
                m.global.selectedVideoID = ""
                m.global.selectedVideoTitle = ""
                m.video.control = "stop"
                ToggleScreen("small")
                m.homeGrid.visible = true
                m.homeGrid.setFocus(true)
                loadHomeContent()
                return true
            end if
        else if key = "OK" AND NOT m.mainMenu.visible then
            if m.videolist.hasFocus() then
                if m.video.state = "error" then
                 return true
                end if
                m.nbrOK = m.nbrOK + 1
                   if m.nbrOK = 2 and   m.videolist.hasFocus()
                         ToggleScreen("full")
                    end if
                if m.video.state = "playing" then
                    if m.global.selectedVideoID = m.videocontent.id
                        ToggleScreen("full")
                    end if
                end if

            else if (m.homeGrid <> invalid) AND m.homeGrid.hasFocus() then
                m.SelectedIndex = m.homegrid.itemSelected
                cId = m.homegrid.content.getChild(m.SelectedIndex).id
                getVideoList(cId)
                m.top.dialog = m.dialog
            end if
        else if key = "options" then
            if m.videolist.hasFocus() OR m.favouriteButton.hasFocus() then
                m.miniKeyboard.visible = true
                m.loadingIndicator.visible = false
                m.video.control = "stop"
                m.video.visible = false
                m.miniKeyboard.setFocus(true)
                m.searched = true
                m.tvPoster.visible = false
                m.favouriteButton.visible = false
                m.videoList.content = invalid
                m.global.selectedVideoID = 0
                m.global.selectedVideoTitle = ""
                return true
            end if
        else if key = "left" then
            if m.miniKeyboard.isInfocusChain() and m.searchContentExist then
                setListFocus()    
            end if
            
            if m.favouriteButton.hasFocus()
                m.videoList.setFocus(true)
            end if
        end if
    else if key = "right"
        if m.videoList.hasFocus() AND NOT m.miniKeyboard.visible
            m.favouriteButton.setFocus(true)
        end if
    else if not press then
        if key = "OK" then
            if m.miniKeyboard.isInfocusChain() then
                searchQuery()
                return true
            else if m.okBtn.hasFocus() then
                m.warningInGroup.visible = false
                if m.closeApp <> 0 then
                    m.top.exitApp = "yes"
                    return false
                end if
                m.homeGrid.setFocus(true)
            else if m.favouriteButton.hasFocus()
                if (m.favouriteButton.text = "Add to Favourites")
                    doRequest("addFavourite", sub(response)
                        if (response.status = "success")
                            m.favouriteButton.text = "Remove from Favourites"
                        else
                            showFavoriteErrorDialog(response.message)
                        end if
                        
                        m.videoList.setFocus(true)
                    end sub, {  
                        baseURL: m.global.BASE_URL,
                        email: getEmail(),
                        channelID: getCurrentFocusedChannelName()
                    })
                else 
                    doRequest("removeFromFavorites", sub(response)
                        if (response.status = "success")
                            m.favouriteButton.text = "Add to Favourites"
                        else
                            showFavoriteErrorDialog(response.message)
                        end if
                        
                        m.videoList.setFocus(true)
                    end sub, {  
                        baseURL: m.global.BASE_URL,
                        email: getEmail(),
                        channelID: getCurrentFocusedChannelName()
                    })
                end if
            end if
        end if
    end if

    return false
end function

sub showFavoriteErrorDialog(message as String)
    msgDialog = CreateObject("roSGNode", "BackDialog")
    msgDialog.buttons = ["OK"]
    msgDialog.buttonGroup.focusBitmapUri = "pkg:/images/button_on.9.png"
    msgDialog.ObserveField("buttonSelected", "onErrorDialogDismiss")
    msgDialog.ObserveField("isBackPressed", "onErrorDialogDismiss")
    msgDialog.title = "Error"
    msgDialog.message = message
    m.top.dialog = msgDialog
end sub

sub onErrorDialogDismiss()
    if m.top.dialog <> invalid
        m.top.dialog.close = true
        m.videoList.setFocus(true)
    end if
end sub

function isMainScreenHasFocus() as boolean
    return m.PortalScreen.isInfocusChain() OR (m.homeGrid <> invalid AND m.homegrid.isInFocusChain()) OR m.ManageListsScreen.isInFocusChain() OR (m.rokuSignUp <> invalid AND m.rokuSignUp.isInFocusChain())
end function

function ToggleScreen(mode)
    m.mode = mode
    if m.mode = "small" then
        m.video.width = 576
        m.video.height = 325
        m.video.translation = [598, 106]
        m.video.enableUI = false
        m.loadingIndicator.width = 547
        m.loadingIndicator.height = 309
        m.loadingIndicator.translation= [608,144]
    else
        m.loadingIndicator.width = 1280
        m.loadingIndicator.height = 720
        m.loadingIndicator.translation= [0,0]
        m.video.width = 1280
        m.video.height = 720
        m.video.translation = [0, 0]
        m.video.setFocus(true)
        m.video.enableUI = true
        m.nbrOK = 0
    end if
end function

function searchQuery(resetList = false as Boolean)
    m.searchContentExist = false
    m.noResults.visible = false
    searchString = m.miniKeyboard.text
    
    if (m.searchTask <> invalid)
        m.searchTask.control = "STOP"
    end if
    
    if resetList or searchString = "" then
        content = createObject("roSGNode", "ContentNode")
        for i = 0 to m.allVideoList.count() step 1
            itemcontent = content.createChild("VideoNode")
            itemcontent.setFields(m.allVideoList[i])
        end for
        if searchString = "" then m.searchContentExist = true
        
         m.videolist.content = content
    else
        m.searchTask = doRequest("search", sub(response)
            m.searchContentExist = response.content <> invalid AND response.content.getChildCount() > 0
            m.videolist.content = response.content
            isInValidResult = response.content = invalid OR response.content.getChildCount() = 0
            
            if NOT isInValidResult
                m.global.selectedVideoID = response.content.getChild(0).id
                m.global.selectedVideoTitle = response.content.getChild(0).TITLE
            end if 
            
            m.noResults.visible = isInValidResult
        end sub, {
            baseURL: m.global.BASE_URL,
            email: getEmail(),
            keyword: searchString
        })
    end if
end function

function setListFocus()
    m.miniKeyboard.visible = false
    m.favouriteButton.visible = true
    m.video.visible = true
    m.tvPoster.visible = true
    m.videolist.setFocus(true)  
end function

function getVideoList(cId as String)
    doRequest("getVideoContent", sub(response)
        m.allVideoList = response.videoItems
        showvideolist(response.content)
    end sub, {
        baseURL: m.global.BASE_URL
        email: getEmail()
        videoId: cId
    })
end function

sub showvideolist(content as Object)
    if (content.getChildCount() = 0)
        showNoVideoDialog()
        return
    end if
    
    if m.top.dialog <> invalid
        m.top.dialog.close = true
    end if
    
    m.videolist.content = content
    m.searchGroup.visible = true
    m.homeGrid.visible = false
    m.videoDetailScreen.visible = true
    m.videolist.setFocus(true)
    
    'play the first video in the list
    if (m.global.isSubscribe)
        playvideo(0)
    end if    
end sub

sub showNoVideoDialog()
    msgDialog = CreateObject("roSGNode", "BackDialog")
    msgDialog.buttons = ["OK"]
    msgDialog.buttonGroup.focusBitmapUri = "pkg:/images/button_on.9.png"
    msgDialog.ObserveField("buttonSelected", "onDismiss")
    msgDialog.ObserveField("isBackPressed", "onDismiss")
    msgDialog.title = "No video in this category"
    m.top.dialog = msgDialog
end sub

sub onDismiss()
    if m.top.dialog <> invalid
        m.top.dialog.close = true
    end if
end sub