' ********** Copyright 2015 Roku Corp.  All Rights Reserved. **********

' Home scene initialization, interaction between RokuSignUp component and API mockup in the Main thread
sub Main(args as Dynamic)
    screen = CreateObject("roSGScreen")
    scene = screen.CreateScene("MainScene")
    
    port = CreateObject("roMessagePort")
    token = getSavedToken()
    isLoggedIn = len(token) > 0
    
    m.global = screen.getGlobalNode()
    m.global.addField("isSubscribe", "bool", false)
    m.global.addField("isLoggedIn", "bool", false)
    m.global.addField("device_email", "string", false)
    m.global.addField("appColor", "string", false)
    m.global.addField("token", "string", false)
    m.global.addField("proxy", "string", false)
    'using this because re-useable feature of Roku rowlist case multiple selection
    m.global.addField("selectedVideoID", "string", false)
    m.global.addField("selectedVideoTitle", "string", false)
    m.global.addField("portalFavourites", "assocarray", false)

    m.global.proxy = ""
    m.global.appColor = "0x662d91"
    m.global.isSubscribe = false
    m.global.isLoggedIn = isLoggedIn
    m.global.selectedVideoId = ""
    m.global.portalFavourites = {
        live: {}
        vods: {}
        series: {}
    }

    'set email into global variable
    m.global.device_email = ""
    
    'set a global variable for the API BASE URL
    m.global.addField("BASE_URL", "string", false)
    m.global.BASE_URL = m.global.proxy + "https://www.sageiptv.co"
    screen.SetMessagePort(port)
    screen.Show()
    scene.args = args

    rokuSignUp = scene.findNode("rokuSignUp")
    rokuSignUp.textTermsOfUse = getTermsOfUse()
    
    while true
        msg = wait(0, port)
        msgType = type(msg)
    end while

    screen.Close()
end sub
